<?php
header("Access-Control-Allow-Origin: http://localhost:3000");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Allow-Headers: Content-Type");
header("Access-Control-Allow-Credentials: true");

// Include the database configuration
include('config.php');

// Function to handle errors and return JSON response
function returnResponse($success, $message, $data = null) {
    $response = array("success" => $success, "message" => $message);
    if ($data !== null) {
        $response['data'] = $data;
    }
    echo json_encode($response);
    exit;
}

// Database connection
$conn = new PDO("mysql:host={$dbHost};dbname={$dbName}", $dbUser, $dbPassword);
$conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

// Handle GET request
if ($_SERVER["REQUEST_METHOD"] === "GET") {
    try {
        $sql = "SELECT * FROM complaints"; 
        $stmt = $conn->query($sql);
        $complaints = $stmt->fetchAll(PDO::FETCH_ASSOC);
        
        returnResponse(true, "Complaints fetched successfully.", $complaints);
    } catch (PDOException $e) {
        returnResponse(false, "Database Error: " . $e->getMessage());
    }
}

// Handle unsupported request method
returnResponse(false, "Unsupported request method.");
?>
