<?php
header("Access-Control-Allow-Origin: http://localhost:3000");
header("Access-Control-Allow-Methods: GET, POST, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");
header("Access-Control-Allow-Credentials: true");

// Include the database connection configuration
include('config.php');

// Fetch selected bank from the query parameters
$selectedBank = isset($_GET['selectedBank']) ? $_GET['selectedBank'] : null;

// Fetch data for chart based on the selected bank
$chartDataQuery = "SELECT status, COUNT(*) AS count FROM complaints WHERE bankName = ? GROUP BY status";
$chartDataStmt = $conn->prepare($chartDataQuery);
$chartDataStmt->execute([$selectedBank]);
$chartData = $chartDataStmt->fetchAll(PDO::FETCH_ASSOC);

// Initialize counts for each category
$totalCount = 0;
$receivedCount = 0;
$resolvedCount = 0;
$unresolvedCount = 0;
$closedCount = 0;

// Iterate through the fetched data and update counts for each category
foreach ($chartData as $dataPoint) {
    // Update total count
    $totalCount += $dataPoint['count'];

    // Update counts for each category
    switch ($dataPoint['status']) {
        case 'received':
            $receivedCount = $dataPoint['count'];
            break;
        case 'resolved':
            $resolvedCount = $dataPoint['count'];
            break;
        case 'unresolved':
            $unresolvedCount = $dataPoint['count'];
            break;
        case 'closed':
            $closedCount = $dataPoint['count'];
            break;
    }
}

// Structure the data with the desired keys
$result = [
    ['name' => 'total', 'count' => $totalCount],
    ['name' => 'received', 'count' => $receivedCount],
    ['name' => 'resolved', 'count' => $resolvedCount],
    ['name' => 'unresolved', 'count' => $unresolvedCount],
    ['name' => 'closed', 'count' => $closedCount]
];

// Return the chart data as JSON
echo json_encode($result);

?>
