<?php
header("Access-Control-Allow-Origin: http://localhost:3000");
header("Access-Control-Allow-Methods: POST, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");
header("Access-Control-Allow-Credentials: true");

// Include the database configuration
include('config.php');

// Function to generate a unique reset token
function generateResetToken() {
    return bin2hex(random_bytes(32));
}

// Function to send a password reset email
function sendResetEmail($email, $resetToken) {
    $resetLink = "http://localhost/compbk/reset-password.php?token=$resetToken";

    $subject = "Password Reset";
    $message = "To reset your password, click the following link:\n\n$resetLink";

    mail($email, $subject, $message);
}

// Handle form submission
if ($_SERVER["REQUEST_METHOD"] == "POST") {
    $email = isset($_POST["email"]) ? $conn->real_escape_string($_POST["email"]) : '';


    // Check if the email exists in the database
    $result = $conn->query("SELECT * FROM admin_user WHERE email = '$email'");

    if ($result === false) {
        // Log the SQL error for debugging
        error_log("SQL Error: " . $conn->error);

        // Send a generic error response
        http_response_code(500);
        echo json_encode(array("success" => false, "message" => "Internal Server Error"));
        exit;
    }

    if ($result->num_rows > 0) {
        // User found, generate and store reset token
        $resetToken = generateResetToken();
        $conn->query("UPDATE admin_user SET reset_token = '$resetToken' WHERE email = '$email'");

        // Send password reset email
        sendResetEmail($email, $resetToken);

        echo json_encode(array("success" => true, "message" => 'Password reset email sent. Check your inbox.'));
    } else {
        echo json_encode(array("success" => false, "message" => 'Email not found in our records.'));
    }
} else {
    echo json_encode(array("success" => false, "message" => 'Invalid request method.'));
}

// Close the database connection
$conn->close();



?>
