<?php
header("Access-Control-Allow-Origin: http://localhost:3000");
header("Access-Control-Allow-Methods: PUT");
header("Access-Control-Allow-Headers: Content-Type");
header("Access-Control-Allow-Credentials: true");

// Include the database configuration
include('config.php');

// Function to handle errors and return JSON response
function returnResponse($success, $message, $data = null) {
    $response = array("success" => $success, "message" => $message);
    if ($data !== null) {
        $response['data'] = $data;
    }
    echo json_encode($response);
    exit;
}

// Database connection
$conn = new PDO("mysql:host={$dbHost};dbname={$dbName}", $dbUser, $dbPassword);
$conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

// Handle PUT Operation (Soft Delete)
if ($_SERVER["REQUEST_METHOD"] == "PUT") {
    // Extract Staff ID from request
    $staffId = $_GET['staffId'];

    // Perform soft delete
    try {
        $sql = "UPDATE staff SET deleted = 1 WHERE staffId = :staffId";
        $stmt = $conn->prepare($sql);
        $stmt->bindParam(':staffId', $staffId);
        $stmt->execute();
        returnResponse(true, "Staff record soft deleted successfully");
    } catch (PDOException $e) {
        returnResponse(false, "Error soft deleting staff record: " . $e->getMessage());
    }
}

// Handle unsupported request method
returnResponse(false, "Unsupported request method.");
?>
