<?php
header("Access-Control-Allow-Origin: http://localhost:3000");
header("Access-Control-Allow-Methods: PUT, POST, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");
header("Access-Control-Allow-Credentials: true");

require 'vendor/autoload.php'; 
include('config.php');

// Function to handle errors and return JSON response with error code
function returnResponse($success, $message, $errorCode = null) {
    if ($errorCode) {
        echo json_encode(array("success" => $success, "message" => $message, "errorCode" => $errorCode));
    } else {
        echo json_encode(array("success" => $success, "message" => $message));
    }
    exit;
}

function generateRandomPassword() {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $length = 8;
    $randomString = '';
    for ($i = 0; $i < $length; $i++) {
        $randomString .= $characters[rand(0, strlen($characters) - 1)];
    }
    return $randomString;
}

if ($_SERVER["REQUEST_METHOD"] == "POST") {
    $staffName = isset($_POST["staffName"]) ? $_POST["staffName"] : '';
    $staffEmail = isset($_POST["staffEmail"]) ? $_POST["staffEmail"] : '';
    $staffRoles = isset($_POST["staffRoles"]) ? $_POST["staffRoles"] : '';

    if (empty($staffName) || empty($staffEmail) || empty($staffRoles)) {
        returnResponse(false, "Please provide all required fields.");
    }

    try {
        $sqlCheck = "SELECT * FROM staff WHERE staffName = ? OR staffEmail = ?";
        $stmtCheck = $conn->prepare($sqlCheck);
        $stmtCheck->execute([$staffName, $staffEmail]);
        $existingStaff = $stmtCheck->fetch();

        if ($existingStaff) {
            returnResponse(false, "Staff with the same name or email already exists.");
        }
    } catch (PDOException $e) {
        returnResponse(false, "Error checking staff: " . $e->getMessage(), $e->getCode());
    }

    $username = strtolower(str_replace(' ', '', $staffName));
    $password = generateRandomPassword();
    $hashedPassword = md5($password);

    try {
        $sql = "INSERT INTO staff (staffName, staffEmail, staffRoles, username, password) VALUES (?, ?, ?, ?, ?)";
        $stmt = $conn->prepare($sql);
        $stmt->execute([$staffName, $staffEmail, $staffRoles, $username, $hashedPassword]);

        $mail = new PHPMailer\PHPMailer\PHPMailer(true);
        try {
            $mail->SMTPDebug = 2;
            $mail->isSMTP();
            $mail->Host = 'mail.tecbank.com.ng';
            $mail->Port = 587;
            $mail->SMTPSecure = 'tls';
            $mail->SMTPAuth = true;
            $mail->Username = 'customerservice@tecbank.com.ng';
            $mail->Password = 'c!&s?=pAtTHh';

            $mail->setFrom('customerservice@tecbank.com.ng', 'Your Name');
            $mail->addAddress($staffEmail);     

            $mail->isHTML(true);                                  
            $mail->Subject = 'Your Login Details';
            $mail->Body    = 'Hello ' . $staffName . '!<br><br>Your profile has been created on the CPD Portal, below are your login details:<br><br>Username: ' . $username . '<br>Password: ' . $password;        

            $mail->send();
            returnResponse(true, "Staff added successfully!. Email sent to staff email containing with login details.");
        } catch (Exception $e) {
            returnResponse(true, "Staff added successfully. Failed to send email: " . $mail->ErrorInfo, $e->getCode());
        }
    } catch (PDOException $e) {
        returnResponse(false, "Error adding staff: " . $e->getMessage(), $e->getCode());
    }
}

returnResponse(false, "Unsupported request method.");
?>
