<?php

header("Access-Control-Allow-Origin: http://localhost:3000");
header("Access-Control-Allow-Methods: GET, POST, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");
header("Access-Control-Allow-Credentials: true");

// Include the database configuration
include('config.php');

try {
    // Create a new PDO instance
    $conn = new PDO("mysql:host={$dbHost};dbname={$dbName}", $dbUser, $dbPassword);

    // Set the PDO error mode to exception
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    // Fetch staff list data from the database
    $stmt = $conn->prepare("SELECT * FROM staff");
    $stmt->execute();
    $staffList = $stmt->fetchAll(PDO::FETCH_ASSOC);

    // Set headers for CSV file download
    header('Content-Type: text/csv; charset=utf-8');
    header('Content-Disposition: attachment; filename=staff_list.csv');

    // Open file handle to write CSV data
    $output = fopen('php://output', 'w');

    // Write CSV header
    fputcsv($output, array_keys($staffList[0]));

    // Write staff list data to CSV
    foreach ($staffList as $row) {
        fputcsv($output, $row);
    }

    // Close file handle
    fclose($output);

} catch (PDOException $e) {
    // Handle database connection errors
    echo "Error: " . $e->getMessage();
}

// Close the database connection
$conn = null;

?>
