<?php
header("Access-Control-Allow-Origin: https://shape.lol");
header("Access-Control-Allow-Methods: GET, PUT");
header("Access-Control-Allow-Headers: Content-Type");
header("Access-Control-Allow-Credentials: true");

// Include the database configuration
include('config.php');

// Function to handle errors and return JSON response
function returnResponse($success, $message, $data = null) {
    $response = array("success" => $success, "message" => $message);
    if ($data !== null) {
        $response['data'] = $data;
    }
    echo json_encode($response);
    exit;
}

// Database connection
$conn = new PDO("mysql:host={$dbHost};dbname={$dbName}", $dbUser, $dbPassword);
$conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

// Handle GET Operation
if ($_SERVER["REQUEST_METHOD"] == "GET") {
    // Retrieve bank_profile data from the database
    try {
    // Inside the GET handler of viewbank.php
    $sql = "SELECT * FROM bank_profile WHERE deleted = 0"; // Assuming 'deleted' column indicates soft-deleted records
    $stmt = $conn->query($sql);
    $BankData = $stmt->fetchAll(PDO::FETCH_ASSOC);
    returnResponse(true, "Bank data retrieved successfully", $BankData);

    } catch (PDOException $e) {
        returnResponse(false, "Error fetching bank data: " . $e->getMessage());
    }
}

// Handle PUT Operation (Update)
if ($_SERVER["REQUEST_METHOD"] == "PUT") {
    // Extract updated bank data from request
    $data = json_decode(file_get_contents("php://input"), true);

    // Perform update operation
    try {
        $sql = "UPDATE bank_profile SET bankName = :bankName, bankEmail = :bankEmail, bankPhone = :bankPhone WHERE bankID = :bankID";
        $stmt = $conn->prepare($sql);
        $stmt->bindParam(':bankName', $data['bankName']);
        $stmt->bindParam(':bankEmail', $data['bankEmail']);
        $stmt->bindParam(':bankPhone', $data['bankPhone']);
        $stmt->bindParam(':bankID', $data['bankID']);
        $stmt->execute();
        returnResponse(true, "Bank record updated successfully");
    } catch (PDOException $e) {
        returnResponse(false, "Error updating bank record: " . $e->getMessage());
    }
}

// Handle unsupported request method
returnResponse(false, "Unsupported request method.");
?>
